clear, close, clc;
% Programmer   : Muhammad Agus Zainuddin
% Last editted : 8 March 2016
% Low Weight Coding with weight 4 codeword length 16
%-----------   Input   ----------------
% Lena_gray.JPG
% AdobeUpdater.dll
% lena256.bmp
% news_cif.mp4
% BUSqcif7_5.yuv
% cancer256.bmp

%-----------   Input   ----------------
% Programmer   : Muhammad Agus Zainuddin
% Last editted : 8 March 2016
% Minimum Energy Channel(MEC) Coding


%-----------   Input   ----------------
%tic
load chan_lwc.mat; % load Distance: d, Bit error rate: ber0, ber1 and ber.
% Binary stream
L = 1e6;
binary_sequence = randsrc(1, L,[0 1;.5 .5]);  % Information bits
Num_1_Uncode = sum(binary_sequence);
% MEC Coding.

% LWC Encoding
k = 3; %
n = 16;
% w = 4; % distance
%n = 16;
load lwc_weight_3.mat;  
comb = lwc_3(1:2^k); clear lwc_3;

% Coding table
tab = zeros(2^k,2);
for i = 1:2^k, 
    tab(i,:) = [i-1 comb(i)];
end
LWC_sym = de2bi(comb,n,'left-msb'); 

disp('--- Encoding Process ---'),
binary_nbits = buffer(binary_sequence,k)';
%clear binary_sequence;
symbol_nbits = bi2de(binary_nbits,'left-msb')';
clear binary_nbits;
trans_bits = zeros(length(symbol_nbits),n);
for i = 1:length(symbol_nbits),
    ind = find(symbol_nbits(i) == tab(:,1));    %ind2 indeks coding
    trans_bits(i,:) = LWC_sym(ind,:);
end

Num_1_LWC = sum(sum(trans_bits));
Energy_efficiency = 100 * (Num_1_Uncode - Num_1_LWC) / Num_1_Uncode
% Count the number of sequential 1
trans_bits_seq = reshape(trans_bits',1,size(trans_bits,1)*size(trans_bits,2));
clear trans_bits;

ber_lwc = zeros(size(d));
for i = 1:length(d),
    % Decoding Process
    disp(i);
    noise = zeros(size(trans_bits_seq));
    for j = 1:length(trans_bits_seq),
        acak = rand;
        if trans_bits_seq(j) == 0,
            if acak < ber0(i), % here
                noise(j) = 1;
            end
        elseif trans_bits_seq(j) == 1,
            if acak < ber1(i),    % here
                noise(j) = 1;
            end
        end
    end
    recvword = mod(trans_bits_seq + noise,2);
    %recvword = trans_bits_seq; %cek if there is no errors.

    %disp('--- Decoding Process ---');
    %--- Estimate the transmitted symbols ---
    symbol_recv = bi2de(buffer(recvword, n)','left-msb')';
    clear recvword;
    symbol_est = zeros(size(symbol_recv));
    for j = 1:length(symbol_recv),
        for x = 1:size(tab,1),
            if (symbol_recv(j) == tab(x,2)),
                symbol_est(j) = tab(x,1);
                break;
            else
                symbol_est(j) = 0;
            end
        end
    end  
    clear symbol_recv;
    sym_bit = de2bi(symbol_est,k,'left-msb'); clear symbol_est;
    recv_bit = reshape(sym_bit',1,size(sym_bit,1)*size(sym_bit,2));
    binary_est = recv_bit(1:L); clear recv_bit;
    [ner, ber_lwc(i)] = biterr(binary_sequence,binary_est);   
end

loglog(d,ber,d,ber_lwc,'-o','linewidth',2), % ,d,ber_mec,'-o'
xlabel('Distance (m)'), ylabel('Bit error rate'),
ylim([1/L 1]),
legend('Uncoded','LWC'), grid on % ,'Simulation',
