clear, close all, clc;
% Programmer   : Muhammad Agus Zainuddin
% Last editted : 5 April 2015
% Description  : Minimum Energy Channel (MEC) Coding for image 


%-----------   Input   ----------------
% lena256.bmp
% cancer256.bmp
% blood1.tif

%-----------  Input  ----------------
I = double(imread('cancer128.bmp'));        % Read the Image
data = reshape(I',1,size(I,1)*size(I,2));   % convert to single stream symbols
data_bit = de2bi(data,8,'left-msb');        % convert each symbol to binary
clear data;
binary_sequence = reshape(data_bit',1,size(data_bit,1)*size(data_bit,2));
L = length(binary_sequence);
clear data_bit;
Num_Uncode = sum(binary_sequence);           % Number of 1 in binary input stream
% Percentage of 1 in binary input stream
Percent_uncode = 100 * Num_Uncode / length(binary_sequence);   

% Transmission channel
load noise_10cm.mat;
noise = noise(1:L);
recv_bits = mod(binary_sequence + noise,2);

img_sym = bi2de(buffer(recv_bits,8)','left-msb');
%clear recv_bits;
Image_est = buffer(img_sym,size(I,1))'; 
clear img_sym;
Image_est = Image_est(1:size(I,1),:);
Q = 255;
MSE  = sum(sum((Image_est - I).^ 2)) / (size(I,1)*size(I,2));

Image = uint8(Image_est);
PSNRbits = 10*log10(Q*Q/MSE);

imshow(Image), title('Uncode'),
   xlabel(['PSNR = ',num2str(PSNRbits),' dB']) 