%% Positive going monopulse
x = 1/(sqrt(2*pi)*sigma)*exp(-(t-t0).^2/(2*sigma^2)); %Gaussian pulse function
xn = x./sqrt(sum(x.^2)./fs)*sqrt(Emax); %Total energy Emax

X = fft(xn,NFFT)/L;
S_X = 1./fs*L.*(X(1:NFFT/2+1).*conj(X(1:NFFT/2+1)));

%% Perform several derivatives
for i=1:Nderiv
    x(1:L-1) = diff(x)./diff(t);
    x(L) = 0;
    xn = x./sqrt(sum(x.^2)./fs)*sqrt(Emax);

    X = fft(xn,NFFT)/L;
    S_X = 1./fs*L.*(X(1:NFFT/2+1).*conj(X(1:NFFT/2+1)));
end
real_t = sum(abs(xn)>0.01*max(xn))*t(2); % This is to see the pulse power